#!/usr/bin/perl  


###Libraries###

use strict;       
use warnings;       
use CGI;      
 

###Main Program###

my $ajax = new();
my $clientData = $ajax->getDataFromClient();
my @factorResult = $ajax->factor($clientData);
$ajax->sendResultToClient(@factorResult);


### Subroutines ###

# Ajax Class  

sub new       
{       
    my $class = shift;       

    my $self = {};       

    bless($self, $class);       

    $self->{CGI} = CGI->new();       

    print $self->{CGI}->header("text/html;charset=UTF-8;q=0.9,*/*;q=0.8");       

    return $self;       
}       

#Method that receives data from the client

sub getDataFromClient       
{       
    my $self = shift;    
        
    return $self->{CGI}->param("number");       
}       

#Method that sends the result to the client

sub sendResultToClient       
{   
    my @result = @_;
    shift @result;

    print "@result";
}     

#Method that computes all the prime factors of the number sent by the client

sub factor       
{
    my $number = $_[1];
    my @result;

    #Number of 2s that divide $number are inserted in the list
    while($number % 2 == 0)
    {
        push(@result, 2);
        $number = $number / 2;
    }
        
    #The divider will be odd from now on, and is inserted in the list if divides $number
    for ( my $divider = 3; $divider <= sqrt($number); $divider = $divider + 2 ) 
    {
        next if $number % $divider;
        $number /= $divider;
        push(@result, $divider);
        redo;
    } 

    #If the $number is prime and greater than 2, it will be inserted in the list
    if($number > 2)
    {
        push(@result, $number);	
    }           

    return @result;
}                   


