//The number 4294967295 was selected by running the command `perl -e "print ~0"` on the terminal of the
//machine the perl script was running, to determine the maximum unsigned integer that perl can handle without loss.
//This can change depending on the architecture (32bit/64bit) of the machine the perl script is running.
var MAXUINT = 4294967295;

var factor = {

    factor: function() 
    {
        var numberFld = $("#number");
        var resultFld = $("#result");

        if(!isPositiveInteger(numberFld.val()))
        {
            alert("Please insert a positive integer number.");
            numberFld.focus();
            numberFld.select();
            return;
        }
        else if(!isWithinRange(numberFld.val()))
        {
            alert("Please insert a number within 2 - 4294967295 range.");
            numberFld.focus();
            numberFld.select();
            return;
        }

    	result = "Factoring " + numberFld.val() + ", please wait...";
    	resultFld.text(result);

        $.ajax({
            type: "POST",
            url:"/cgi-bin/factor.cgi",
            data: { number: numberFld.val() },

            success:function(result)
            {
                result = result.replace(/ /g, " x ");
                resultFld.text("Prime factors for number " + numberFld.val() + " = " + result);
            },
            error: function(jqXHR, textStatus, errorThrown)
            {
                resultFld.text("*** " + textStatus + ": " + errorThrown + " ***");               
            }
        });
    }
 };


function isPositiveInteger(val) 
{   
    //Checks if the value inserted is a number, not float and greater than zero
    if ($.isNumeric(val) && Math.floor(val) == val && Number(val) > 0)
    {
        return true;
    } 

    return false;
}

function isWithinRange(val) 
{   
    //Checks if the value inserted is bigger than 1 and less than MAXUINT 
    if (Number(val) > 1 && Number(val) <= MAXUINT)
    {
        return true;
    } 

    return false;
}


